#!/usr/bin/perl

use GD;

# $B=i4|CMFI$_(B

%form = &read_input;

print "Content-type: image/gif\n\n";

$bred=$form{'bred'}		if defined( $form{'bred'} );
$bgreen=$form{'bgreen'}		if defined( $form{'bgreen'} );
$bblue=$form{'bblue'}		if defined( $form{'bblue'} );
$tred=$form{'tred'}		if defined( $form{'tred'} );
$tgreen=$form{'tgreen'}		if defined( $form{'tgreen'} );
$tblue=$form{'tblue'}		if defined( $form{'tblue'} );


# create a new image
$im = new GD::Image(500,30);

# aloocate some colors
$bcolorbox=$im->colorAllocate($bred,$bgreen,$bblue);
$tcolorbox=$im->colorAllocate($tred,$tgreen,$tblue);

$im->interlaced('true');

# Draw rectangle
$im->rectangle(0,0,499,29,$colorbox);

# Draw Text
$im->string(gdLargeFont,100,10,"ABCDEFGHIJKLMNOPQRSTUVWXYZ",$tcolorbox);

print $im->gif;

#
sub read_input
{
    local ($buffer, @pairs, $pair, $name, $value, %FORM);
    # Read in text
    $ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
    if ($ENV{'REQUEST_METHOD'} eq "POST")
    {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    } else
    {
	$buffer = $ENV{'QUERY_STRING'};
    }
    @pairs = split(/&/, $buffer);
    foreach $pair (@pairs)
    {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%(..)/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
    }
    %FORM;
}

